#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include <dshow.h>
#include "resource.h"

#pragma comment(lib,"strmiids.lib")
#pragma comment(lib,"comctl32.lib")

#define MYWNDTITLE		"VideoRecorder"
#define MAX_VENC		64	// 񋓂rfIRvbT̍ő吔
#define MAX_FMT			64	// 񋓂o̓tH[}bg̍ő吔
#define RELEASE(p)		if (p){p->Release();p=NULL;}

ICaptureGraphBuilder2	*g_pCGB = NULL;
IGraphBuilder			*g_pGB	= NULL;
IVideoWindow			*g_pVW  = NULL;
IMediaControl			*g_pMC	= NULL;
IBaseFilter				*g_pSrc = NULL;		// Lv` tB^
IBaseFilter				*g_pVEnc[MAX_VENC];	// rfI RvbT tB^
IAMVfwCaptureDialogs	*g_pCD  = NULL;		// ݒ_CAO

HWND					g_hDlg   = NULL;
HWND					g_hPic   = NULL;
HWND					g_hComb1 = NULL;
HWND					g_hSttcWDM[8],g_hSldrWDM[8],g_hChckWDM[2];

typedef struct{
	SIZE	SizeMax;	// o͍őTCY
	UINT	FpsMin;		// t[[gŏl
	UINT	FpsMax;		// t[[gől
}INFO_SIZE;

INFO_SIZE	g_SZ[MAX_FMT];

typedef struct{
	bool	bSuccess;						// il̎擾tO
	long	Min,Max,Step,Default,Flags,Val;	// il̃ftHgAL͈͂Ȃ
}INFO_QUALITY;

INFO_QUALITY	g_QL[10];

bool	g_bWDM = 0;			// 0:VFW, 1:WDM
int		g_wdh = 0,g_hgt = 0;// o̓TCY
int		g_fmt_ct = 0;		// 񋓂ꂽo̓tH[}bg
UINT	g_venc_idx = 0;		// IꂽrfIRvbT̔ԍ
UINT	g_mode_idx = 0;		// s[hi0:ޭ, 1:^, 2:ޭ+^j
char	g_savename[MAX_PATH] = "MyAviFile.avi";	// ۑt@C

int		CALLBACK ProcDlg(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
int		CALLBACK ProcDlgWDM(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void	Stop();
void	Run_Preview();
void	Init_Dialog();
void	Init_DialogWDM(HWND hDlg);
void	Set_DialogWDM();
void	Set_QualityWDM1();
void	Reset_QualityWDM();
bool	Init_Capture(bool bInit);
void	Show_DlgVFW(UINT iDlg);
bool	Set_DlgSettingVFW();
bool	Change_SizeWDM();
bool	Get_SizeWDM();
bool	Get_QualityWDM();
bool	Get_QualityWDM_Sub(int idx, long Property);
void	Set_QualityWDM2();
bool	Set_QualityWDM_Sub(int idx, long Property);
bool	Enum_Filters(REFCLSID clsid);
void	Save_FileDlg();
void	Cleanup1();
void	Cleanup2();

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG		msg;
	HWND	hDlg;
	
	hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, ProcDlg);
	ShowWindow(hDlg, nCmdShow);
	
	while(GetMessage(&msg, NULL, 0, 0)) {
		if (IsDialogMessage(hDlg, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

int CALLBACK ProcDlg(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		g_hDlg = hDlg;
		Init_Dialog();
		break;

	case WM_COMMAND:
		switch(wParam)
		{
		case IDM_SAVEDLG:	// ۑt@C̎w
			Save_FileDlg();
			break;
		
		case IDM_EXIT:		// I
		case IDC_EXIT:
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		
		case IDM_SETTING1:	// \[X̐ݒ(VFW)
			Show_DlgVFW(VfwCaptureDialog_Source);
			break;
		
		case IDM_SETTING2:	// tH[}bg̐ݒ(VFW)
			Show_DlgVFW(VfwCaptureDialog_Format);
			break;
		
		case IDM_SETTING3:	// fBXvC̐ݒ(VFW)
			Show_DlgVFW(VfwCaptureDialog_Display);
			break;
		
		case IDM_SETTINGWDM:// iݒ(WDM)
			DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_DIALOG2), hDlg, ProcDlgWDM);
			break;
		
		case IDC_COMBO1 | (CBN_SELCHANGE<<16): // RvbT̑I
			g_venc_idx = SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0);
			if(!Init_Capture(0)){
				SendMessage(hDlg,WM_CLOSE,0,0);
				return 0;
			}
			break;
		
		case IDC_COMBO2 | (CBN_SELCHANGE<<16): // s[h̑I
			g_mode_idx = SendDlgItemMessage(hDlg,IDC_COMBO2,CB_GETCURSEL,0,0);
			if(g_mode_idx == 0){
				EnableWindow(g_hComb1, FALSE);
			}
			else{
				EnableWindow(g_hComb1, TRUE);
			}
			if(!Init_Capture(0)){
				SendMessage(hDlg,WM_CLOSE,0,0);
				return 0;
			}
			break;
		
		case IDC_COMBO3 | (CBN_SELCHANGE<<16): // o̓TCY̑I(WDM)
			char buf[32];
			SendDlgItemMessage(hDlg,IDC_COMBO3,WM_GETTEXT,sizeof(buf),(LPARAM)buf);
			sscanf(buf,"%d~%d",&g_wdh,&g_hgt);
			Run_Preview();
			break;
		
		case IDC_RUN | (BN_CLICKED<<16):	// ^Evr[Jn
			if(g_pMC){
				g_pMC->Run();
				if(g_mode_idx != 0){
					char s[256];
					sprintf(s,"^撆EEE %s",MYWNDTITLE);
					SendMessage(g_hDlg,WM_SETTEXT,0,(LPARAM)s);
				}
			}
			break;
		
		case IDC_STOP | (BN_CLICKED<<16):	// ^Evr[I
			if(g_pMC){
				g_pMC->Stop();
				SendMessage(g_hDlg,WM_SETTEXT,0,(LPARAM)MYWNDTITLE);
			}
			break;
		
		default:
			return FALSE;
		}
		break;
	
	case WM_CLOSE:
		DestroyWindow(hDlg);
		Cleanup2();
		PostQuitMessage(0);
		break;
	
	default:
		return FALSE;
	}
	return TRUE;
}// ProcDlg

// WDMiݒ_CAOvV[W
int CALLBACK ProcDlgWDM(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		Init_DialogWDM(hDlg);
		break;
		
	case WM_COMMAND:
		switch(wParam)
		{
		case IDC_BUTTON1:	// Zbg
			Reset_QualityWDM();
			Run_Preview();
			break;
		case IDOK:			// Kp
			Set_QualityWDM1();
			Run_Preview();
			break;
		case IDCANCEL:		// I
			EndDialog(hDlg,FALSE);
			break;
		default:
			return FALSE;
		}
		break;
		
	default:
		return FALSE;
	}
	return TRUE;
}// ProcDlgWDM

void Stop()
{
	if(g_pMC){
		g_pMC->Stop();
		CheckRadioButton(g_hDlg,IDC_RUN,IDC_STOP,IDC_STOP);
	}
}// Stop

// vr[Ŏs
void Run_Preview()
{
	g_mode_idx = 0;
	SendDlgItemMessage(g_hDlg,IDC_COMBO2,CB_SETCURSEL,g_mode_idx,0);
	EnableWindow(g_hComb1, FALSE);
	if(!Init_Capture(0)){
		SendMessage(g_hDlg,WM_CLOSE,0,0);
		return;
	}
	if(g_pMC){
		g_pMC->Run();
		CheckRadioButton(g_hDlg,IDC_RUN,IDC_STOP,IDC_RUN);
	}
}// Run_Preview

// C _CAȌ
void Init_Dialog()
{
	g_hPic   = GetDlgItem(g_hDlg, IDC_PIC1);
	g_hComb1 = GetDlgItem(g_hDlg, IDC_COMBO1);
	if(FAILED(CoInitialize(NULL))){
		MessageBox(g_hDlg,"COM ̏Ɏs܂",MYWNDTITLE,MB_OK);
		SendMessage(g_hDlg,WM_CLOSE,0,0);
		return;
	}
	// rfIRvbT̗
	if(!Enum_Filters(CLSID_VideoCompressorCategory)){
		MessageBox(g_hDlg,"rfIRvbT񋓂ł܂",MYWNDTITLE,MB_OK);
		SendMessage(g_hDlg,WM_CLOSE,0,0);
		return;
	}
	SendDlgItemMessage(g_hDlg,IDC_COMBO1,CB_SETCURSEL,g_venc_idx,0);
	// s[h̏
	char mode[][32] = {"ޭ","^","ޭ + ^"};
	int i;
	for(i=0;i<3;i++){
		SendDlgItemMessage(g_hDlg,IDC_COMBO2,CB_ADDSTRING,0,(LPARAM) mode[i]);
	}
	SendDlgItemMessage(g_hDlg,IDC_COMBO2,CB_SETCURSEL,0,0);
	// IuWFNg̏
	if(!Init_Capture(1)){
		SendMessage(g_hDlg,WM_CLOSE,0,0);
		return;
	}
	// TCYύXR{{bNX̏(WDM)
	char	buf[32];
	SendDlgItemMessage(g_hDlg,IDC_COMBO3,CB_RESETCONTENT,0,0);
	for(i=0;i<g_fmt_ct;i++){
		_snprintf(buf,sizeof(buf),"%d~%d",g_SZ[i].SizeMax.cx,g_SZ[i].SizeMax.cy);
		SendDlgItemMessage(g_hDlg,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)buf);
	}
	int idx;
	_snprintf(buf,sizeof(buf),"%d~%d",g_wdh,g_hgt);
	idx = SendDlgItemMessage(g_hDlg,IDC_COMBO3,CB_FINDSTRING,-1,(LPARAM)buf);
	if(idx != -1){
		SendDlgItemMessage(g_hDlg,IDC_COMBO3,CB_SETCURSEL,idx,0);
	}
}// Init_Dialog

// WDM_CAȌ
void Init_DialogWDM(HWND hDlg)
{
	InitCommonControls();
	g_hSttcWDM[0] = GetDlgItem(hDlg, IDC_STATIC1);
	g_hSttcWDM[1] = GetDlgItem(hDlg, IDC_STATIC2);
	g_hSttcWDM[2] = GetDlgItem(hDlg, IDC_STATIC3);
	g_hSttcWDM[3] = GetDlgItem(hDlg, IDC_STATIC4);
	g_hSttcWDM[4] = GetDlgItem(hDlg, IDC_STATIC5);
	g_hSttcWDM[5] = GetDlgItem(hDlg, IDC_STATIC6);
	g_hSttcWDM[6] = GetDlgItem(hDlg, IDC_STATIC7);
	g_hSttcWDM[7] = GetDlgItem(hDlg, IDC_STATIC8);
	g_hSldrWDM[0] = GetDlgItem(hDlg, IDC_SLIDER1);
	g_hSldrWDM[1] = GetDlgItem(hDlg, IDC_SLIDER2);
	g_hSldrWDM[2] = GetDlgItem(hDlg, IDC_SLIDER3);
	g_hSldrWDM[3] = GetDlgItem(hDlg, IDC_SLIDER4);
	g_hSldrWDM[4] = GetDlgItem(hDlg, IDC_SLIDER5);
	g_hSldrWDM[5] = GetDlgItem(hDlg, IDC_SLIDER6);
	g_hSldrWDM[6] = GetDlgItem(hDlg, IDC_SLIDER7);
	g_hSldrWDM[7] = GetDlgItem(hDlg, IDC_SLIDER8);
	g_hChckWDM[0] = GetDlgItem(hDlg, IDC_CHECK1);
	g_hChckWDM[1] = GetDlgItem(hDlg, IDC_CHECK2);
	for(int i=0;i<8;i++){
		SendMessage(g_hSldrWDM[i],TBM_SETTICFREQ,500,0);
		SendMessage(g_hSldrWDM[i],TBM_SETRANGE,FALSE,MAKELONG(0,1000));
	}
	Set_DialogWDM();
}// Init_DialogWDM

// Rg[ɒlݒ
void Set_DialogWDM()
{
	int i;
	for(i=0;i<8;i++){
		if(g_QL[i].Flags == 2 && g_QL[i].bSuccess){
			UINT pos = (g_QL[i].Val - g_QL[i].Min) * 1000 / (g_QL[i].Max - g_QL[i].Min);
			SendMessage(g_hSldrWDM[i],TBM_SETPOS,TRUE,pos);
		}
		else{
			EnableWindow(g_hSttcWDM[i],FALSE);
			EnableWindow(g_hSldrWDM[i],FALSE);
		}
	}
	for(i=0;i<2;i++){
		if(g_QL[i+8].Flags == 2 && g_QL[i+8].bSuccess){
			if(g_QL[i+8].Val){
				SendMessage(g_hChckWDM[i],BM_SETCHECK,BST_CHECKED,0);
			}
			else{
				SendMessage(g_hChckWDM[i],BM_SETCHECK,BST_UNCHECKED,0);
			}
		}
		else{
			EnableWindow(g_hChckWDM[i],FALSE);
		}
	}
}// Set_DialogWDM

// il̐ݒ1(WDM)
void Set_QualityWDM1()
{
	int i;
	for(i=0;i<8;i++){
		if(g_QL[i].Flags == 2 && g_QL[i].bSuccess){
			UINT pos = SendMessage(g_hSldrWDM[i],TBM_GETPOS,0,0);
			g_QL[i].Val = pos * (g_QL[i].Max - g_QL[i].Min) / 1000 + g_QL[i].Min;
			g_QL[i].Val = g_QL[i].Val - (g_QL[i].Val % g_QL[i].Step);
		}
	}
	for(i=0;i<2;i++){
		if(g_QL[i+8].Flags == 2 && g_QL[i+8].bSuccess){
			ULONG r = SendMessage(g_hChckWDM[i],BM_GETCHECK,0,0);
			if(r == BST_CHECKED){
				g_QL[i+8].Val = 1;
			}
			else{
				g_QL[i+8].Val = 0;
			}
		}
	}
}// Set_QualityWDM1

// ilftHgɃZbg(WDM)
void Reset_QualityWDM()
{
	int i;
	for(i=0;i<10;i++){
		g_QL[i].Val = g_QL[i].Default;
	}
	Set_DialogWDM();
}// Reset_QualityWDM

// tB^Ot}l[W̍쐬ƃI[fBIfoCX̗
// bInit: _CAÔƂTRUEAȊOAFALSE
bool Init_Capture(bool bInit)
{
	HRESULT 				hr;
	LPOLESTR				pClsid = NULL;
	ICreateDevEnum			*pEnum = NULL;
	IEnumMoniker			*pEm = NULL;
	IMoniker				*pM = NULL;
	ULONG					cFetched;
	bool					flag;
	char					buf[256];
	
	Cleanup1();
	
	RELEASE(g_pGB);
	hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
						  IID_IGraphBuilder, (void **)&g_pGB);
	if(FAILED(hr)){
		return FALSE;
	}
	RELEASE(g_pCGB);
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER, 
						  IID_ICaptureGraphBuilder2, (void **)&g_pCGB);
	if(FAILED(hr)){
		return FALSE;
	}
	// gptB^Otw
	if(FAILED(g_pCGB->SetFiltergraph(g_pGB))){
		return FALSE;
	}
	// rfI Lv` foCX̗񋓁i͗񋓂Ȃōŏ̂擾j
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
							IID_ICreateDevEnum, (void**)&pEnum);
	if(FAILED(hr)){
		return FALSE;
	}
	hr = pEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pEm, 0);
	if(FAILED(hr)){
		RELEASE(pEnum);
		return FALSE;
	}
	RELEASE(pEnum);
	if(!pEm){
		MessageBox(g_hDlg,"̓foCX܂",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	flag = 0;
	pEm->Reset();
	if(S_OK == pEm->Next(1, &pM, &cFetched))
	{
		IPropertyBag *pBag;
		hr = pM->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pBag);
		if(SUCCEEDED(hr))
		{
			VARIANT var;
			var.vt = VT_BSTR;
			hr = pBag->Read(L"FriendlyName", &var, NULL);
			if(SUCCEEDED(hr))
			{
				WideCharToMultiByte(CP_ACP, 0, var.bstrVal, -1, buf, sizeof(buf), NULL, NULL);
				SysFreeString(var.bstrVal);
				RELEASE(g_pSrc);
				hr = pM->BindToObject(NULL, NULL, IID_IBaseFilter, (void**)&g_pSrc);
				if(FAILED(hr)){
					flag = 1;
				}
			}
			RELEASE(pBag);
		}
		RELEASE(pM);
	}
	RELEASE(pEm);
	if(flag || !g_pSrc){
		return FALSE;
	}
	// rfI Lv` tB^̒ǉ
	if(FAILED(g_pGB->AddFilter(g_pSrc, L"Video Capture"))){
		return FALSE;
	}
	// o̓tH[}bgȂǂ̐ݒ菀
	if(bInit){
		if(!Set_DlgSettingVFW()){
			g_bWDM = 1;
			Get_QualityWDM();
			Get_SizeWDM();
		}
	}
	else{
		if(g_bWDM){
			if(!Change_SizeWDM()){
				MessageBox(g_hDlg,"TCYύXł܂",MYWNDTITLE,MB_OK);
			}
			Set_QualityWDM2();
		}
	}
	if(g_mode_idx != 0){
		// rfI RvbT tB^̒ǉ
		if(g_pVEnc[g_venc_idx]){
			if(FAILED(g_pGB->AddFilter(g_pVEnc[g_venc_idx], L"Video Compressor"))){
				return FALSE;
			}
		}
		// o̓t@C̐ݒ AviMuxtB^̎擾Eǉ
		WCHAR	wSaveName[MAX_PATH];
		MultiByteToWideChar(CP_ACP,0,g_savename,-1,wSaveName,sizeof(wSaveName));
		IBaseFilter *pMux = NULL;
		hr = g_pCGB->SetOutputFileName(&MEDIASUBTYPE_Avi, wSaveName, &pMux, NULL);
		if(FAILED(hr)){
			return FALSE;
		}
		// \[XtB^VideoCompressorAviMuxt@CC^ڑ
		hr = g_pCGB->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, g_pSrc, g_pVEnc[g_venc_idx], pMux);
		if(FAILED(hr)){
			RELEASE(pMux);
			return FALSE;
		}
		RELEASE(pMux);
		if(g_mode_idx == 2){	// 2:ޭ+^ޭ
			hr = g_pCGB->RenderStream(&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, g_pSrc, NULL, NULL);
			if (FAILED(hr)){
				return FALSE;
			}
		}
	}
	else{						// 0:ޭޭ
		hr = g_pCGB->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, g_pSrc, NULL, NULL);
		if (FAILED(hr)){
			return FALSE;
		}
	}
	RELEASE(g_pSrc);
	// IVideoWindow
	if(g_mode_idx != 1){
		RELEASE(g_pVW);
		if(FAILED(g_pGB->QueryInterface(IID_IVideoWindow, (void **)&g_pVW))){
			return FALSE;
		}
		if(FAILED(g_pVW->put_Owner((OAHWND)g_hPic))){
			RELEASE(g_pVW);
			return FALSE;
		}
		if(FAILED(g_pVW->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS))){
			RELEASE(g_pVW);
			return FALSE;
		}
		long	v_wdh,v_hgt;
		IBasicVideo	*pBV;
		if(FAILED(g_pGB->QueryInterface(IID_IBasicVideo, (void**)&pBV))){
			RELEASE(g_pVW);
			return FALSE;
		}
		pBV->GetVideoSize(&v_wdh, &v_hgt);
		RELEASE(pBV);
		RECT	rc;
		int		wdh,hgt;
		GetClientRect(g_hPic,&rc);
		wdh = 320;		// vr[̃TCY
		hgt = 240;
		g_pVW->SetWindowPosition((rc.right-wdh)/2, (rc.bottom-hgt)/2, wdh, hgt);
	}
	// IMediaControl
	RELEASE(g_pMC);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaControl, (void**)&g_pMC))){
		return FALSE;
	}
	return TRUE;
}// Init_Capture

// foCX VFW ̏ꍇ̃_CAO\
void Show_DlgVFW(UINT iDlg)
{
	if(g_pCD){
		Stop();
		if(g_pVW){
			g_pVW->put_Visible(OAFALSE);
			g_pVW->put_Owner(NULL);
		}
		g_pCD->ShowDialog(iDlg, g_hDlg);
		if(g_pVW){
			g_pVW->put_Owner((OAHWND)g_hPic);
			g_pVW->put_Visible(OATRUE);
		}
	}
}// Show_DlgVFW

// foCX VFW ̏ꍇ̐ݒύX
bool Set_DlgSettingVFW()
{
	HRESULT	hr;
	HMENU	hMenu,hMenuSub;
	if(!g_pCGB){
		return FALSE;
	}
	hMenu = GetMenu(g_hDlg);
	if(hMenu){
		hMenuSub = GetSubMenu(hMenu,1);
	}
	if(!hMenuSub){
		return FALSE;
	}
	RELEASE(g_pCD);
	hr = g_pCGB->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video,
							g_pSrc, IID_IAMVfwCaptureDialogs, (void **)&g_pCD);
	if(FAILED(hr)){
		EnableMenuItem(hMenuSub, IDM_SETTING1, MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(hMenuSub, IDM_SETTING2, MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(hMenuSub, IDM_SETTING3, MF_BYCOMMAND | MF_GRAYED);
		return FALSE;
	}
	EnableMenuItem(hMenuSub, IDM_SETTINGWDM, MF_BYCOMMAND | MF_GRAYED);
	if(FAILED(g_pCD->HasDialog(VfwCaptureDialog_Source))){
		EnableMenuItem(hMenuSub, IDM_SETTING1, MF_BYCOMMAND | MF_GRAYED);
	}
	if(FAILED(g_pCD->HasDialog(VfwCaptureDialog_Format))){
		EnableMenuItem(hMenuSub, IDM_SETTING2, MF_BYCOMMAND | MF_GRAYED);
	}
	if(FAILED(g_pCD->HasDialog(VfwCaptureDialog_Display))){
		EnableMenuItem(hMenuSub, IDM_SETTING3, MF_BYCOMMAND | MF_GRAYED);
	}
	return TRUE;
}// Set_DlgSettingVFW

// foCX WDM ̏ꍇ̃TCYύX
bool Change_SizeWDM()
{
	HRESULT hr;
	int		ct = 0,size = 0;
	if(!g_pCGB){
		return FALSE;
	}
	Stop();
	IAMStreamConfig	*pSC = NULL;
	hr = g_pCGB->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video,
							g_pSrc, IID_IAMStreamConfig, (void **)&pSC);
	if(FAILED(hr)){
		return FALSE;
	}
	AM_MEDIA_TYPE mt;
	ZeroMemory(&mt, sizeof(AM_MEDIA_TYPE));
	mt.majortype = MEDIATYPE_Video;
	mt.subtype   = MEDIASUBTYPE_RGB24;
	mt.pbFormat  = (BYTE*)CoTaskMemAlloc(sizeof(VIDEOINFOHEADER));
	if(mt.pbFormat == NULL){
		CoTaskMemFree(mt.pbFormat);
		RELEASE(pSC);
		return FALSE;
	}
	VIDEOINFOHEADER *pVH = (VIDEOINFOHEADER*)mt.pbFormat;
	ZeroMemory(pVH, sizeof(VIDEOINFOHEADER));
	pVH->bmiHeader.biBitCount  = 24;
	pVH->bmiHeader.biWidth     = g_wdh;
	pVH->bmiHeader.biHeight    = g_hgt;
	pVH->bmiHeader.biPlanes    = 1;
	pVH->bmiHeader.biSize      = sizeof(BITMAPINFOHEADER);
	pVH->bmiHeader.biSizeImage = DIBSIZE(pVH->bmiHeader);

	mt.formattype        = FORMAT_VideoInfo;
	mt.cbFormat          = sizeof(VIDEOINFOHEADER);
	mt.bFixedSizeSamples = TRUE;
	mt.lSampleSize       = DIBSIZE(pVH->bmiHeader);
	if(FAILED(pSC->SetFormat(&mt))){
		CoTaskMemFree(mt.pbFormat);
		RELEASE(pSC);
		return FALSE;
	}
	CoTaskMemFree(mt.pbFormat);
	RELEASE(pSC);
	return TRUE;
}// Change_SizeWDM

// foCX WDM ̏ꍇ̃TCYύX
bool Get_SizeWDM()
{
	HRESULT hr;
	int		ct = 0,size = 0;
	if(!g_pCGB){
		return FALSE;
	}
	IAMStreamConfig	*pSC = NULL;
	hr = g_pCGB->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video,
							g_pSrc, IID_IAMStreamConfig, (void **)&pSC);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(pSC->GetNumberOfCapabilities(&ct, &size))){
		RELEASE(pSC);
		return FALSE;
	}
	if(size == sizeof(VIDEO_STREAM_CONFIG_CAPS)){
		VIDEO_STREAM_CONFIG_CAPS	scc;
		AM_MEDIA_TYPE				*pmt;
		g_fmt_ct = 0;
		for(int i=0;i<ct;i++){
			if(SUCCEEDED(pSC->GetStreamCaps(i, &pmt, (BYTE*)&scc))){
				if( pmt->majortype  == MEDIATYPE_Video && 
					pmt->subtype    == MEDIASUBTYPE_RGB24 &&
					pmt->formattype == FORMAT_VideoInfo && 
					pmt->pbFormat   != NULL)
				{
					g_SZ[g_fmt_ct].SizeMax = scc.MaxOutputSize;
					if(scc.MinFrameInterval > 0 && scc.MinFrameInterval < 10000000){
						g_SZ[g_fmt_ct].FpsMin  = (UINT)(10000000 / scc.MinFrameInterval);
					}
					else{
						g_SZ[g_fmt_ct].FpsMin  = 1;
					}
					if(scc.MaxFrameInterval > 0 && scc.MaxFrameInterval < 10000000){
						g_SZ[g_fmt_ct].FpsMax  = (UINT)(10000000 / scc.MaxFrameInterval);
					}
					else{
						g_SZ[g_fmt_ct].FpsMax  = 1;
					}
					if(g_fmt_ct == 0){
						VIDEOINFOHEADER *pVH = (VIDEOINFOHEADER*)pmt->pbFormat;
						g_wdh = pVH->bmiHeader.biWidth;
						g_hgt = pVH->bmiHeader.biHeight;
					}
					g_fmt_ct ++;
					if(g_fmt_ct >= MAX_FMT){
						CoTaskMemFree(pmt->pbFormat);
						CoTaskMemFree(pmt);
						break;
					}
				}
				CoTaskMemFree(pmt->pbFormat);
				CoTaskMemFree(pmt);
			}
		}
	}
	RELEASE(pSC);
	return TRUE; 
}// Get_SizeWDM

// il̎擾(WDM)
bool Get_QualityWDM()
{
	for(int i=0;i<10;i++){
		g_QL[i].bSuccess = 1;
	}
	if(!Get_QualityWDM_Sub(0, VideoProcAmp_Brightness)){
		g_QL[0].bSuccess = 0;
	}
	if(!Get_QualityWDM_Sub(1, VideoProcAmp_Contrast)){
		g_QL[1].bSuccess = 0;
	}
	if(!Get_QualityWDM_Sub(2, VideoProcAmp_Hue)){
		g_QL[2].bSuccess = 0;
	}
	if(!Get_QualityWDM_Sub(3, VideoProcAmp_Saturation)){
		g_QL[3].bSuccess = 0;
	}
	if(!Get_QualityWDM_Sub(4, VideoProcAmp_Sharpness)){
		g_QL[4].bSuccess = 0;
	}
	if(!Get_QualityWDM_Sub(5, VideoProcAmp_Gamma)){
		g_QL[5].bSuccess = 0;
	}
	if(!Get_QualityWDM_Sub(6, VideoProcAmp_WhiteBalance)){
		g_QL[6].bSuccess = 0;
	}
	if(!Get_QualityWDM_Sub(7, VideoProcAmp_Gain)){
		g_QL[7].bSuccess = 0;
	}
	if(!Get_QualityWDM_Sub(8, VideoProcAmp_ColorEnable)){
		g_QL[8].bSuccess = 0;
	}
	if(!Get_QualityWDM_Sub(9, VideoProcAmp_BacklightCompensation)){
		g_QL[9].bSuccess = 0;
	}

/*	char s[256];
	sprintf(s,"min:%ld max:%ld step:%ld def:%ld flag:%ld val:%ld\n",g_QL[0].Min,g_QL[0].Max,g_QL[0].Step,g_QL[0].Default,g_QL[0].Flags,g_QL[0].Val);
	MessageBox(0,s,"",0);
*/	return TRUE;
}// Get_QualityWDM

// il擾̃Tu֐(WDM)
// idx     : [OUT] PxʓxȂǂ̃ftHglL͈͂擾 g_QL[] ̔ԍ
// Property: [IN]  VideoProcAmpProperty 񋓂̒l
bool Get_QualityWDM_Sub(int idx, long Property)
{
	HRESULT hr;
	IAMVideoProcAmp	*pPA = NULL;
	hr = g_pSrc->QueryInterface(IID_IAMVideoProcAmp, (void**)&pPA);
	if(FAILED(hr)){
		return FALSE;
	}
	hr = pPA->GetRange(Property, &g_QL[idx].Min, &g_QL[idx].Max, &g_QL[idx].Step, &g_QL[idx].Default, &g_QL[idx].Flags);
	if(FAILED(hr)){
		RELEASE(pPA);
		return FALSE;
	}
	if(FAILED(pPA->Get(Property, &g_QL[idx].Val, &g_QL[idx].Flags))){
		RELEASE(pPA);
		return FALSE;
	}
	RELEASE(pPA);
	return TRUE;
}// Get_QualityWDM_Sub

// il̐ݒ2(WDM)
void Set_QualityWDM2()
{
	Set_QualityWDM_Sub(0, VideoProcAmp_Brightness);
	Set_QualityWDM_Sub(1, VideoProcAmp_Contrast);
	Set_QualityWDM_Sub(2, VideoProcAmp_Hue);
	Set_QualityWDM_Sub(3, VideoProcAmp_Saturation);
	Set_QualityWDM_Sub(4, VideoProcAmp_Sharpness);
	Set_QualityWDM_Sub(5, VideoProcAmp_Gamma);
	Set_QualityWDM_Sub(6, VideoProcAmp_WhiteBalance);
	Set_QualityWDM_Sub(7, VideoProcAmp_Gain);
	Set_QualityWDM_Sub(8, VideoProcAmp_ColorEnable);
	Set_QualityWDM_Sub(9, VideoProcAmp_BacklightCompensation);
}// Set_QualityWDM2

// ilݒ̃Tu֐(WDM)
// idx     : [IN] g_QL[] ̔ԍ
// Property: [IN] VideoProcAmpProperty 񋓂̒l
bool Set_QualityWDM_Sub(int idx, long Property)
{
	HRESULT hr;
	if(!g_pSrc){
		return FALSE;
	}
	if(g_QL[idx].Flags == 1 || !g_QL[idx].bSuccess){
		return FALSE;
	}
	IAMVideoProcAmp	*pPA = NULL;
	hr = g_pSrc->QueryInterface(IID_IAMVideoProcAmp, (void**)&pPA);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(pPA->Set(Property, g_QL[idx].Val, VideoProcAmp_Flags_Manual))){
		RELEASE(pPA);
		return FALSE;
	}
	RELEASE(pPA);
	return TRUE;
}// Set_QualityWDM_Sub

// w肳ꂽJeS̃tB^񋓂
// clsid  :[IN]  tB^񋓂JeSCLSID
bool Enum_Filters(REFCLSID clsid)
{
	HRESULT			hr;
	ICreateDevEnum	*pEnum = NULL;
	IEnumMoniker	*pEm = NULL;
	IMoniker		*pM = NULL;
	ULONG			cFetched;
	int				ct;
	char			buf[256];
	
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
							IID_ICreateDevEnum, (void**)&pEnum);
	if(FAILED(hr)){
		return FALSE;
	}
	hr = pEnum->CreateClassEnumerator(clsid, &pEm, 0);
	if(FAILED(hr)){
		RELEASE(pEnum);
		return FALSE;
	}
	RELEASE(pEnum);
	for(int i=0;i<MAX_VENC;i++){
		RELEASE(g_pVEnc[i]);
	}
	g_pVEnc[0] = NULL;
	SendDlgItemMessage(g_hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) "None");
	ct = 1;
	pEm->Reset();
	while(S_OK == pEm->Next(1, &pM, &cFetched))
	{
		IPropertyBag *pBag;
		hr = pM->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pBag);
		if(SUCCEEDED(hr))
		{
			VARIANT var;
			var.vt = VT_BSTR;
			hr = pBag->Read(L"FriendlyName", &var, NULL);
			if(SUCCEEDED(hr))
			{
				WideCharToMultiByte(CP_ACP, 0, var.bstrVal, -1, buf, sizeof(buf), NULL, NULL);
				if(strcmp(buf, "")){
					if(SUCCEEDED(pM->BindToObject(NULL, NULL, IID_IBaseFilter, (void**)&g_pVEnc[ct]))){
						SendDlgItemMessage(g_hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) buf);
						if(!strncmp(buf, "Indeo", 5)){
							g_venc_idx = ct;
						}
						ct ++;
					}
				}
				SysFreeString(var.bstrVal);
			}
			RELEASE(pBag);
		}
		RELEASE(pM);
	}
	RELEASE(pEm);
	if(!ct){
		return FALSE;
	}
	return TRUE;
}// Enum_Filters

// ۑt@C_CAO
void Save_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH];
	
	strncpy(fn, g_savename, sizeof(fn));
	
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = g_hDlg;
	ofn.Flags = OFN_OVERWRITEPROMPT;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter = "AVI̧ (*.avi)\0*.wav\0";
	ofn.nFilterIndex = 1;
	if(GetSaveFileName(&ofn)){
		strncpy(g_savename, fn, sizeof(g_savename));
		if(!strrchr(g_savename, '.')){
			strcat(g_savename, ".avi");
		}
		if(!Init_Capture(0)){
			SendMessage(g_hDlg,WM_CLOSE,0,0);
			return;
		}
	}
}// Save_FileDlg

// IuWFNg̉1
void Cleanup1()
{
	Stop();
	if(g_pVW){
		g_pVW->put_Visible(OAFALSE);
		g_pVW->put_Owner(NULL);
	}
	RELEASE(g_pCD);
	RELEASE(g_pSrc);
	RELEASE(g_pVW);
	RELEASE(g_pMC);
	RELEASE(g_pGB);
	RELEASE(g_pCGB);
}// Cleanup1

// IuWFNg̉2
void Cleanup2()
{
	int i;
	for(i=0;i<MAX_VENC;i++){
		RELEASE(g_pVEnc[i]);
	}
	Cleanup1();
	CoUninitialize();
	// EBhE̔j
	DestroyWindow(g_hPic);
	DestroyWindow(g_hComb1);
	for(i=0;i<8;i++){
		DestroyWindow(g_hSttcWDM[i]);
		DestroyWindow(g_hSldrWDM[i]);
	}
	for(i=0;i<2;i++)
		DestroyWindow(g_hChckWDM[i]);
}// Cleanup2
